package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.UserRoleRes;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserRoleResSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<UserRoleRes> selectCond;
	private JSONObject customsearchval;
	public UserRoleResSearchFilter(){
		this.page =new Page<UserRoleRes>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<UserRoleRes>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_uniresid_eq;

	public void setN_uniresid_eq(String n_uniresid_eq) {
        this.n_uniresid_eq = n_uniresid_eq;
        if(!StringUtils.isEmpty(this.n_uniresid_eq)){
            this.selectCond.eq("uniresid", n_uniresid_eq);
        }
    }
	private String n_uniresname_eq;

	public void setN_uniresname_eq(String n_uniresname_eq) {
        this.n_uniresname_eq = n_uniresname_eq;
        if(!StringUtils.isEmpty(this.n_uniresname_eq)){
            this.selectCond.eq("uniresname", n_uniresname_eq);
        }
    }
	private String n_uniresname_like;

	public void setN_uniresname_like(String n_uniresname_like) {
        this.n_uniresname_like = n_uniresname_like;
        if(!StringUtils.isEmpty(this.n_uniresname_like)){
            this.selectCond.like("uniresname", n_uniresname_like);
        }
    }
	private String n_userroleid_eq;

	public void setN_userroleid_eq(String n_userroleid_eq) {
        this.n_userroleid_eq = n_userroleid_eq;
        if(!StringUtils.isEmpty(this.n_userroleid_eq)){
            this.selectCond.eq("userroleid", n_userroleid_eq);
        }
    }
	private String n_userrolename_eq;

	public void setN_userrolename_eq(String n_userrolename_eq) {
        this.n_userrolename_eq = n_userrolename_eq;
        if(!StringUtils.isEmpty(this.n_userrolename_eq)){
            this.selectCond.eq("userrolename", n_userrolename_eq);
        }
    }
	private String n_userrolename_like;

	public void setN_userrolename_like(String n_userrolename_like) {
        this.n_userrolename_like = n_userrolename_like;
        if(!StringUtils.isEmpty(this.n_userrolename_like)){
            this.selectCond.like("userrolename", n_userrolename_like);
        }
    }
	private String n_userroleresname_like;

	public void setN_userroleresname_like(String n_userroleresname_like) {
        this.n_userroleresname_like = n_userroleresname_like;
        if(!StringUtils.isEmpty(this.n_userroleresname_like)){
            this.selectCond.like("userroleresname", n_userroleresname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLERES_UNIRES_UNIRESID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_uniresid_eq("NA");
			}
			else{
				this.setN_uniresid_eq(strParentkey);
			}
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_USERROLERES_USERROLE_USERROLEID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_userroleid_eq("NA");
			}
			else{
				this.setN_userroleid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("userroleresname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}